#version 430 core
out vec4 FragColor;
out vec4 BrightColor;

in vec2 TexCoords;
uniform sampler2D scene;

void main()
{

    FragColor = texture(scene, TexCoords);

    //filter bright colors for bloom
  	float brightness = dot(FragColor.rgb, vec3(0.2126, 0.7152, 0.0722));
  	if (brightness > 1.0 )
  	{
  		vec3 op = clamp(FragColor.rgb, vec3(0), vec3(255));
  		BrightColor = vec4(op * 0.1, FragColor.a);
  	}else
   		BrightColor = vec4(0.0, 0.0, 0.0, FragColor.a);
}
